/*
 * Ben NanoNote stage 1 payload test.
 *
 * Copyright (C) 2015 Paul Boddie <paul@boddie.org.uk>
 * Copyright (C) Wolfgang Spraul <wolfgang@sharism.cc>
 *
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation; either version 3 of the License, or (at your option) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "jz4740.h"
#include "board-nanonote.h"
#include "usb_boot_defines.h"

struct fw_args *fw_args;
volatile u32 CPU_ID;
volatile u32 UART_BASE;
volatile u32 CONFIG_BAUDRATE;
volatile u8 SDRAM_BW16;
volatile u8 SDRAM_BANK4;
volatile u8 SDRAM_ROW;
volatile u8 SDRAM_COL;
volatile u8 CONFIG_MOBILE_SDRAM;
volatile u32 CFG_CPU_SPEED;
volatile u32 CFG_EXTAL;
volatile u8 PHM_DIV;
volatile u8 IS_SHARE;

void load_args(void)
{
        fw_args = (struct fw_args *)0x80002008; /* get the fw args from memory */
        CPU_ID = fw_args->cpu_id ;
        CFG_EXTAL = (u32)fw_args->ext_clk * 1000000;
        CFG_CPU_SPEED = (u32)fw_args->cpu_speed * CFG_EXTAL ;
        if (CFG_EXTAL == 19000000) {
                CFG_EXTAL = 19200000;
                CFG_CPU_SPEED = 192000000;
        }
        PHM_DIV = fw_args->phm_div;
        UART_BASE = UART0_BASE + fw_args->use_uart * 0x1000;
        CONFIG_BAUDRATE = fw_args->boudrate;
        SDRAM_BW16 = fw_args->bus_width;
        SDRAM_BANK4 = fw_args->bank_num;
        SDRAM_ROW = fw_args->row_addr;
        SDRAM_COL = fw_args->col_addr;
        CONFIG_MOBILE_SDRAM = fw_args->is_mobile;
        IS_SHARE = fw_args->is_busshare;
}

void c_main(void)
{
	load_args();
	gpio_init();
	pll_init();
	sdram_init();
}
